package download.com.learnfiles.speech;

import android.content.ActivityNotFoundException;
import android.content.Intent;
import android.speech.RecognizerIntent;
import android.speech.tts.TextToSpeech;
import android.support.v7.app.AppCompatActivity;
import android.os.Bundle;
import android.view.View;
import android.widget.Button;
import android.widget.EditText;
import android.widget.Toast;

import java.lang.reflect.Array;
import java.util.ArrayList;
import java.util.Locale;

public class MainActivity extends AppCompatActivity {

    Button btnSpeak;
    Button btnMic;
    EditText txtText;

    TextToSpeech tts;


    @Override
    protected void onCreate(Bundle savedInstanceState) {
        super.onCreate(savedInstanceState);
        setContentView(R.layout.activity_main);

        txtText=(EditText)findViewById(R.id.txtText);
        btnSpeak=(Button)findViewById(R.id.btnSpeak) ;
        btnMic=(Button)findViewById(R.id.btnMic) ;

        tts=new TextToSpeech(this, new TextToSpeech.OnInitListener() {
            @Override
            public void onInit(int status) {

                if (status==TextToSpeech.SUCCESS)
                {

                    int result=tts.setLanguage(Locale.US);

                    if (result==TextToSpeech.LANG_MISSING_DATA||result==TextToSpeech.LANG_NOT_SUPPORTED)
                    {
                        Toast.makeText(getApplicationContext(),"This language not supported ....",Toast.LENGTH_SHORT).show();
                        btnSpeak.setEnabled(false);
                    }



                }else
                {
                    Toast.makeText(getApplicationContext(),"Init failed ...",Toast.LENGTH_SHORT).show();
                }

            }
        });



        btnSpeak.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {
                tts.speak(txtText.getText().toString(),TextToSpeech.QUEUE_FLUSH,null);
            }
        });




        btnMic.setOnClickListener(new View.OnClickListener() {
            @Override
            public void onClick(View view) {

                Intent intent=new Intent(RecognizerIntent.ACTION_RECOGNIZE_SPEECH);

                intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE_MODEL,RecognizerIntent.LANGUAGE_MODEL_FREE_FORM);

                intent.putExtra(RecognizerIntent.EXTRA_LANGUAGE,"fa");

                intent.putExtra(RecognizerIntent.EXTRA_PROMPT,"Learnfiles.com");

                try {
                    startActivityForResult(intent, 100);
                }catch (ActivityNotFoundException e)
                {
                    Toast.makeText(getApplicationContext(),"Your device not supported .",Toast.LENGTH_SHORT).show();
                }




            }
        });



    }

    @Override
    protected void onActivityResult(int requestCode,int resultCode,Intent data)
    {

        Toast.makeText(getApplicationContext(),"Learnfiles.com",Toast.LENGTH_SHORT).show();

        if (requestCode==100)
        {
            if (resultCode==RESULT_OK&&data !=null)
            {
                ArrayList<String> result=data.getStringArrayListExtra(RecognizerIntent.EXTRA_RESULTS);
                txtText.setText(result.get(0));

            }
        }

    }
}
